#!/bin/sh
#
# This script is (C) 1999-2000 Riccardo Facchetti.
#
# A big thank you to SuSE people that send me, as a gift, their distribution.
# This enabled me to test this script with SuSE 6.0 and will test with 6.2
# ASAP (just arrived on my desk, I need time to upgrade 6.0 to 6.2).
#
# Modified by Kaspar P. Klingholz for handling `exit 0' at the end of
# halt.local

MAGICWORD="XXX APCUPSD - DO NOT EDIT XXX"
prefix=/usr                         # $MAGICWORD
exec_prefix=${prefix}               # $MAGICWORD
APCCONTROL="/etc/apcupsd/apccontrol killpower"

function remove_halt_local()
{
# Note: Old versions of SuSE installer have had a bug: Last "fi"
# command was not commented by $MAGICWORD and was not replaced during
# update. This script tries to detect such orphan "fi".
	sed ':1;/XXX APCUPSD - DO NOT EDIT XXX/,+1s/^fi$/& # XXX APCUPSD - DO NOT EDIT XXX/;t1' </etc/init.d/halt.local | grep -v "$MAGICWORD" > /etc/init.d/halt.local.tmp
	mv /etc/init.d/halt.local.tmp /etc/init.d/halt.local
}

case "$1" in
install)

if [ -f /etc/init.d/halt.local ]
then
        remove_halt_local
        # Install new sequence even if there is already installed.
        # check for last line is "exit 0" as in SuSE 5.2
        RESULT=`tail -n 1 /etc/init.d/halt.local`
        if [ "$RESULT" = "exit 0" ]
        then
                echo "Last line in /etc/init.d/halt.local is \"exit 0\""
                NUM=`grep -c "" /etc/init.d/halt.local`
                NUM="$(echo $NUM | \
                awk '{print $1 -1}')"
                head -n $NUM /etc/init.d/halt.local > /etc/init.d/halt.local.tmp
                mv /etc/init.d/halt.local.tmp /etc/init.d/halt.local
                chmod u+x /etc/init.d/halt.local
                echo "... removed"
        fi
        echo "Adding apcupsd routines to local halt script..."
        cat >> /etc/init.d/halt.local <<EOF
# Added automatically by apcupsd installation       # $MAGICWORD
if [ -f /etc/apcupsd/powerfail ]; then              # $MAGICWORD
    echo "Power down detected while shutting down." # $MAGICWORD
    echo "Sending all processes the TERM signal..." # $MAGICWORD
    killall5 -15                                    # $MAGICWORD
    # Do a fast kill                                # $MAGICWORD
    sleep 1                                         # $MAGICWORD
    echo "Sending all processes the KILL signal..." # $MAGICWORD
    killall5 -9                                     # $MAGICWORD
    echo "Remounting filesystems read-only."        # $MAGICWORD
    mounts=/etc/fstab                               # $MAGICWORD
    test -r /proc/mounts && mounts=/proc/mounts     # $MAGICWORD
    while read des fs rest; do                      # $MAGICWORD
        mount -v -n -o remount,ro \$fs               # $MAGICWORD
    done < \$mounts                                  # $MAGICWORD
    echo "Preparing UPS to power shutdown."         # $MAGICWORD
    $APCCONTROL               # $MAGICWORD
fi                                                  # $MAGICWORD
EOF
fi
;;
uninstall)
if [ -f /etc/init.d/halt.local ]
then
        RESULT=`grep "$MAGICWORD" /etc/init.d/halt.local`
        if [ -z "$RESULT" ]
        then
                echo "apcupsd halt routines not installed."
        else
                echo "Removing apcupsd routines from local halt script..."
		remove_halt_local
        fi
fi
;;
esac
